<?php
    /** 
    * $Id $
    * vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4:
    *
    * This file is part of GNOPASTE
    *
    * @author   GNOPASTE Development Team <devel@ghcif.de>
    * @since    19/01/2005
    * @version  $Revision $
    *
    * Copyright (C) 2004-2007 by ghcif.de <devel@ghcif.de>
    *
    * This program is free software; you can redistribute it and/or modify
    * it under the terms of the GNU General Public License as published by
    * the Free Software Foundation; either version 2 of the License, or
    * (at your option) any later version.
    *
    * This program is distributed in the hope that it will be useful, 
    * but WITHOUT ANY WARRANTY; without even the implied warranty of
    * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    * GNU General Public License for more details.
    *
    * You should have received a copy of the GNU General Public License
    * along with this program; if not, write to the Free Software
    * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */
    
    /**
    * main settings 
    */
    error_reporting(E_ALL);
    session_start();


    /**
    * access check
    */
    define('IN_GNP', 1);


    /**
    * real path 
    */          
    define('GNP_REAL_PATH', dirname(__FILE__) . '/');
                                
                                                
    /**             
    * relative path 
    */              
    define('GNP_RELATIVE_PATH', ((dirname($_SERVER['PHP_SELF']) == '/') ? ('/') : (dirname($_SERVER['PHP_SELF']) . '/')));

                                                                    
    /**                 
    * url path          
    */                  
    define('GNP_URL_PATH', ((!isset($_SERVER['HTTPS'])) ? ('http://') : ('https://')) . $_SERVER['HTTP_HOST'] . GNP_RELATIVE_PATH);
                                                                                    

    /**
    * config body
    */
    function output_config()
    {
        $config_str  = '<?php' . "\n";
        $config_str .= '    /**' . "\n";
        $config_str .= '    * $Id $' . "\n";
        $config_str .= '    * vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4:' . "\n";
        $config_str .= '    *' . "\n";
        $config_str .= '    * This file is part of GNOPASTE' . "\n";
        $config_str .= '    *' . "\n";
        $config_str .= '    * @author   GNOPASTE Development Team <devel@ghcif.de>' . "\n";
        $config_str .= '    * @since    19/01/2005' . "\n";
        $config_str .= '    * @version  $Revision $' . "\n";
        $config_str .= '    *' . "\n";
        $config_str .= '    * Copyright (C) 2004-2007 by ghcif.de <devel@ghcif.de>' . "\n";
        $config_str .= '    *' . "\n";
        $config_str .= '    * This program is free software; you can redistribute it and/or modify' . "\n";
        $config_str .= '    * it under the terms of the GNU General Public License as published by' . "\n";
        $config_str .= '    * the Free Software Foundation; either version 2 of the License, or' . "\n";
        $config_str .= '    * (at your option) any later version.' . "\n";
        $config_str .= '    *' . "\n";
        $config_str .= '    * This program is distributed in the hope that it will be useful,' . "\n";
        $config_str .= '    * but WITHOUT ANY WARRANTY; without even the implied warranty of' . "\n";
        $config_str .= '    * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the' . "\n";
        $config_str .= '    * GNU General Public License for more details.' . "\n";
        $config_str .= '    *' . "\n";
        $config_str .= '    * You should have received a copy of the GNU General Public License' . "\n";
        $config_str .= '    * along with this program; if not, write to the Free Software' . "\n";
        $config_str .= '    * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.' . "\n";
        $config_str .= '    */' . "\n\n";
        $config_str .= '    $dbhost = \'' . $_SESSION['dbhost'] . '\';' . "\n";
        $config_str .= '    $dbuser = \'' . $_SESSION['dbuser'] . '\';' . "\n";
        $config_str .= '    $dbpasswd = \'' . $_SESSION['dbpasswd'] . '\';' . "\n";
        $config_str .= '    $dbdatabase = \'' . $_SESSION['dbdatabase'] . '\';' . "\n\n";
        $config_str .= '    $tbl_prefix = \'' . $_SESSION['tbl_prefix'] . '\';' . "\n";
        $config_str .= '?>' . "\n";

        return $config_str;
    }

    /**
    * html output
    */
    echo('<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'."\n");
    echo('<html>'."\n");
    echo('  <head>'."\n");
    echo('      <title>gnopaste v0.5.5 install</title>'."\n");
    echo('      <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />'."\n");
    echo('  </head>'."\n");
    echo('  <body>'."\n");
    echo('      <h2>gnopaste v0.5.5 install - ');
    
    /**
    * install switch
    */
    switch(@$_GET['install']) 
    {
        case 'step1':
        
            echo('step 1</h2>'."\n");
            
            /**
            * set session vars if not set
            */
            if(!isset($_SESSION['dbhost']))
            {
                $_SESSION['dbhost'] = 'localhost';
            }
            if(!isset($_SESSION['dbuser']))
            {
                $_SESSION['dbuser'] = 'user';
            }
            if(!isset($_SESSION['dbpasswd']))
            {
                $_SESSION['dbpasswd'] = 'password';
            }
            if(!isset($_SESSION['dbdatabase']))
            {
                $_SESSION['dbdatabase'] = 'database';
            }
            if(!isset($_SESSION['tbl_prefix']))
            {
                $_SESSION['tbl_prefix'] = 'gnopaste_';
            }
            
            if(!isset($_POST['submit']) AND !isset($_GET['write']))
            {
                /**
                * form to set the mysql connection data
                */
                echo('      first we have to set the mysql connection data.<br />'."\n");
                echo('      these vars would be automaticly written to the config.php<br /><br />'."\n");

                echo('      <form action="install.php?install=step1" method="post">'."\n");
                echo('          <table>'."\n");
                echo('              <tr>'."\n");
                echo('                  <td>mysql host</td>'."\n");
                echo('                  <td><input type="text" name="dbhost" style="width:200px;" value="'.$_SESSION['dbhost'].'" /></td>'."\n");
                echo('              </tr>'."\n");
                echo('              <tr>'."\n");
                echo('                  <td>mysql user</td>'."\n");
                echo('                  <td><input type="text" name="dbuser" style="width:200px;" value="'.$_SESSION['dbuser'].'" /></td>'."\n");
                echo('              </tr>'."\n");
                echo('              <tr>'."\n");
                echo('                  <td>mysql password</td>'."\n");
                echo('                  <td><input type="password" name="dbpasswd" style="width:200px;" value="'.$_SESSION['dbpasswd'].'" /></td>'."\n");
                echo('              </tr>'."\n");
                echo('              <tr>'."\n");
                echo('                  <td>mysql database</td>'."\n");
                echo('                  <td><input type="text" name="dbdatabase" style="width:200px;" value="'.$_SESSION['dbdatabase'].'" /></td>'."\n");
                echo('              </tr>'."\n");
                echo('              <tr>'."\n");
                echo('                  <td>mysql table prefix</td>'."\n");
                echo('                  <td><input type="text" name="tbl_prefix" style="width:200px;" value="'.$_SESSION['tbl_prefix'].'" /></td>'."\n");
                echo('              </tr>'."\n");
                echo('              <tr>'."\n");
                echo('                  <td colspan="2"><input type="submit" name="submit" value="send data" /></td>'."\n");
                echo('              </tr>'."\n");
                echo('          </table>'."\n");
                echo('      </form>'."\n");
            }
            else
            {
                /**
                * set postdata to the session
                */
                if(isset($_POST['submit']))
                {
                    $_SESSION['dbhost'] = $_POST['dbhost'];
                    $_SESSION['dbuser'] = $_POST['dbuser'];
                    $_SESSION['dbpasswd'] = $_POST['dbpasswd'];
                    $_SESSION['dbdatabase'] = $_POST['dbdatabase'];
                    $_SESSION['tbl_prefix'] = $_POST['tbl_prefix'];
                }
                
                if(trim(!empty($_SESSION['dbhost'])) AND trim(!empty($_SESSION['dbuser'])) AND trim(!empty($_SESSION['dbpasswd'])) AND trim(!empty($_SESSION['dbdatabase'])))
                {
                    /**
                    * check if config.php exists
                    */
                    if(file_exists(GNP_REAL_PATH . "/config.php"))
                    {
                        if($fpread = @fopen(GNP_REAL_PATH . "/config.php", 'w+') OR isset($_GET['write']) AND $_GET['write'] == 'retry' AND $fpread = @fopen(GNP_REAL_PATH . "/config.php", 'w+'))
                        {
                            /**
                            * write config.php
                            */
                            fputs($fpread, output_config());
                            fclose($fpread);
                            
                            unset($_SESSION['dbhost']);
                            unset($_SESSION['dbuser']);
                            unset($_SESSION['dbpasswd']);
                            unset($_SESSION['dbdatabase']);
                            unset($_SESSION['tbl_prefix']);
                            
                            echo('      config.php file is written <span style="color:green; font-weight:bold;">OK</span><br /><br />'."\n");                           
                                                        
                            /**
                            * chmod config.php back to 644
                            */
                            if(@chmod("config.php", 644))
                            {
                                echo('      chmod for config.php is set to 644 <span style="color:green; font-weight:bold;">OK</span><br /><br />'."\n");
                            }
                            else
                            {
                                echo('      chmod for config.php could not been set to 644 <span style="color:red; font-weight:bold;">FAILED</span><br />'."\n");
                                echo('      info: you have to do this manualy, it is very important for security<br /><br />'."\n");
                            }
                            
                            /**
                            * lets get to the next step
                            */
                            $_SESSION['mysqldata'] = 'true';
                            echo('      <a href="?install=step2">lets get to the next step</a>'."\n");
                        }
                        else
                        {
                            /**
                            * try to chmod to 777 automaticly if fails to write config.php
                            */
                            echo('      can\'t write config.php <span style="color:red; font-weight:bold;">FAILED</span><br />'."\n");
                            echo('      trying to chmod it to 777 ');
                            if(@chmod("config.php", 777))
                            {
                                echo('<span style="color:green; font-weight:bold;">OK</span><br /><br />'."\n");
                            }
                            else
                            {
                                echo('<span style="color:red; font-weight:bold;">FAILED</span><br />'."\n");
                                echo('      info: chmod config.php manualy to 777 and try it again<br /><br />'."\n");
                            }

                            echo('      <a href="?install=step1&amp;write=retry">try again</a>'."\n");
                        }
                    }
                    else
                    {
                        /**
                        * error - cant find config.php
                        */
                        echo('      can\'t find config.php <span style="color:red; font-weight:bold;">FAILED</span><br />'."\n");
                        echo('      info: download the complete version from sf.net/projects/gnopaste<br /><br />'."\n");
                    
                        echo('      installation aborted...'."\n");
                    }
                    
                }
                else
                {
                    /**
                    * error - any db connection data field is empty
                    */
                    echo('      you have to fill out every field <span style="color:red; font-weight:bold;">FAILED</span><br /><br />'."\n");
                    echo('      <a href="?install=step1">back to form</a>'."\n");
                }
            }
            
        break;
        case 'step2':

            echo('step 2</h2>'."\n");
            
            if(isset($_SESSION['mysqldata']) AND $_SESSION['mysqldata'] == 'true')
            {
                /**
                * define session vars if doesnt exist
                */
                if(!isset($_SESSION['site_lang']))
                {
                    $_SESSION['site_lang'] = 'en';
                }
                if(!isset($_SESSION['code_lang']))
                {
                    $_SESSION['code_lang'] = 'Plain Text';
                }
                if(!isset($_SESSION['tab_length']))
                {
                    $_SESSION['tab_length'] = '4';
                }
                if(!isset($_SESSION['page_title']))
                {
                    $_SESSION['page_title'] = 'gnopaste v0.5.5 - brought to you by ghcif.de';
                }
                if(!isset($_SESSION['page_name']))
                {
                    $_SESSION['page_name'] = 'gnopaste';
                }
                if(!isset($_SESSION['layout']))
                {
                    $_SESSION['layout'] = 'gnopaste';
                }
                if(!isset($_SESSION['copyright']))
                {
                    $_SESSION['copyright'] = '&copy; 2004-2007 by <a href="http://www.ghcif.de">ghcif</a>';
                }
                if(!isset($_SESSION['mod_rewrite']))
                {
                    $_SESSION['mod_rewrite'] = '1';
                }
                
                /**
                * includes
                */
                include(GNP_REAL_PATH . 'config.php');
        
                /**
                * connect to db
                */
                if(@mysql_connect($dbhost, $dbuser, $dbpasswd))
                {
                    mysql_select_db($dbdatabase) OR die(mysql_error());
                    echo('      connecting to db <span style="color:green; font-weight:bold;">OK</span><br />'."\n");
                }
                else
                {
                    echo('      connecting to db <span style="color:red; font-weight:bold;">FAILED</span><br />'."\n");
                    echo('      info: you have to set the correct mysql data at step 1<br /><br />'."\n");
                    echo('      <a href="?install=step1">back to step 1</a>'."\n");
                }
                
                /**
                * options for the language selectbox
                */
                $langselect = '';               
                $handle = opendir(GNP_REAL_PATH . 'languages/');
                while ($directory = readdir($handle)) 
                {
                    if($directory != "." AND $directory != ".." AND preg_match('#^.*_main.php$#', $directory)) 
                    {
                        $shortlang = substr($directory, 0, strpos($directory, "_main.php"));
                        $langselect .= '<option value="'.$shortlang.'"';
                        if(isset($_SESSION['site_lang']) AND trim(stripslashes($_SESSION['site_lang'])) == $shortlang)
                        {
                            $langselect .= ' selected="selected"';
                        }
                        $langselect .= '>'.$shortlang.'</option>';
                    }
                }
                closedir($handle); 
                
                /**
                * supported languages array
                */
                $language = array("Plain Text", "C89", "C", "C++", "PHP", "Perl", "Java", "VB", "C#", "Ruby", "Python", "Pascal", "mIRC", "PL/I", "SQL", "XML", "Scheme");
                sort($language);

                /**
                * select optionen for the supported languages
                */
                $lang_option = '';
                foreach($language as $optlang)
                {
                    $lang_option .= '<option value="'.$optlang.'"';
                    if(isset($_SESSION['code_lang']) AND trim(stripslashes($_SESSION['code_lang'])) == $optlang)
                    {
                        $lang_option .= ' selected="selected"';
                    }
                    $lang_option .= '>'.$optlang.'</option>';
                }

                /**
                * select optionen for the tab width
                */
                $tab_option = '';
                for($i = 0; $i <= 9; $i++)
                {
                    $tab_option .= '<option value="'.$i.'"';
                    if(is_numeric($_SESSION['tab_length']) AND trim(stripslashes($_SESSION['tab_length'])) == $i)
                    {
                        $tab_option .= ' selected="selected"';
                    }
                    $tab_option .= '>'.$i.'</option>';
                }
                
                /**
                * layout option
                */
                $layout_option = '';
                $handle = opendir(GNP_REAL_PATH . 'layouts/');
                while ($directory = readdir($handle))
                {   
                    if($directory != "." AND $directory != ".." AND $directory != '.svn' AND is_dir(GNP_REAL_PATH . 'layouts/' . $directory))
                    {   
                        $layout_option .= '<option value="'.$directory.'"';
                        if(isset($_SESSION['layout']) AND trim(stripslashes($_SESSION['layout'])) == $directory)
                        {   
                            $layout_option .= ' selected="selected"';
                        }
                        $layout_option .= '>'.$directory.'</option>';
                    }
                }
                closedir($handle);

                /**
                * select optionen for the mod_rewrite
                */
                $modrewrite_option = '<option value="0"';
                if(is_numeric($_SESSION['mod_rewrite']) AND trim(stripslashes($_SESSION['mod_rewrite'])) == 0)
                {
                    $modrewrite_option .= ' selected="selected"';
                }
                $modrewrite_option .= '>deactivated</option><option value="1"';
                if(is_numeric($_SESSION['mod_rewrite']) AND trim(stripslashes($_SESSION['mod_rewrite'])) == 1)
                {
                    $modrewrite_option .= ' selected="selected"';
                }
                $modrewrite_option .= '>activated</option>';

                /**
                * select options for tab width
                */
                for($i = 0; $i <= 1; $i++)
                {  
                    $tab_option .= '<option value="'.$i.'"';
                    if(is_numeric($_SESSION['tab_length']) AND trim(stripslashes($_SESSION['tab_length'])) == $i)
                    {
                        $tab_option .= ' selected="selected"';
                    }
                    $tab_option .= '>'.$i.'</option>';
                }
                
                /**
                * process form or show form
                */
                if(!isset($_POST['submit']))
                {
                    /**
                    * form to set the main settings
                    */
                    echo('      now we have to set the main settings for gnopaste<br />'."\n");
                    echo('      after you have sent the form the mysql tables will be written automaticly<br />'."\n");
                    echo('      tables with the same name would be overwritten...<br /><br />'."\n");
                
                    echo('      <form action="install.php?install=step2" method="post">'."\n");
                    echo('          <table>'."\n");
                    echo('              <tr>'."\n");
                    echo('                  <td>language</td>'."\n");
                    echo('                  <td><select name="language" style="width:200px;">'.$langselect.'</select></td>'."\n");
                    echo('              </tr>'."\n");
                    echo('              <tr>'."\n");
                    echo('                  <td>page title</td>'."\n");
                    echo('                  <td><input type="text" name="page_title" style="width:200px;" value=\''.stripslashes($_SESSION['page_title']).'\' /></td>'."\n");
                    echo('              </tr>'."\n");
                    echo('              <tr>'."\n");
                    echo('                  <td>page name</td>'."\n");
                    echo('                  <td><input type="text" name="page_name" style="width:200px;" value=\''.stripslashes($_SESSION['page_name']).'\' /></td>'."\n");
                    echo('              </tr>'."\n");
                    echo('              <tr>'."\n");
                    echo('                  <td>copyright</td>'."\n");
                    echo('                  <td><input type="text" name="copyright" style="width:200px;" value=\''.stripslashes($_SESSION['copyright']).'\' /></td>'."\n");
                    echo('              </tr>'."\n");
                    echo('              <tr>'."\n");
                    echo('                  <td>layout</td>'."\n");
                    echo('                  <td><select name="layout" style="width:200px;">'.$layout_option.'</select></td>'."\n");
                    echo('              </tr>'."\n");
                    echo('              <tr>'."\n");
                    echo('                  <td>standard tab width</td>'."\n");
                    echo('                  <td><select name="tab_length" style="width:200px;">'.$tab_option.'</select></td>'."\n");
                    echo('              </tr>'."\n");
                    echo('              <tr>'."\n");
                    echo('                  <td>first selected lang</td>'."\n");
                    echo('                  <td><select name="code_lang" style="width:200px;">'.$lang_option.'</select></td>'."\n");
                    echo('              </tr>'."\n");
                    echo('              <tr>'."\n");
                    echo('                  <td>use mod_rewrite</td>'."\n");
                    echo('                  <td><select name="mod_rewrite" style="width:200px;">'.$modrewrite_option.'</select></td>'."\n");
                    echo('              </tr>'."\n");
                    echo('              <tr>'."\n");
                    echo('                  <td colspan="2"><input type="submit" name="submit" value="send data" /></td>'."\n");
                    echo('              </tr>'."\n");
                    echo('          </table>'."\n");
                    echo('      </form>'."\n");
                }
                else
                {
                    /**
                    * set postdata to session 
                    */
                    $_SESSION['site_lang'] = addslashes(htmlspecialchars($_POST['language']));
                    $_SESSION['page_title'] = addslashes(htmlspecialchars($_POST['page_title']));
                    $_SESSION['page_name'] = addslashes(htmlspecialchars($_POST['page_name']));
                    $_SESSION['layout'] = addslashes(htmlspecialchars($_POST['layout']));
                    $_SESSION['tab_length'] = addslashes(htmlspecialchars($_POST['tab_length']));
                    $_SESSION['code_lang'] = addslashes(htmlspecialchars($_POST['code_lang']));
                    $_SESSION['copyright'] = addslashes($_POST['copyright']);
                    $_SESSION['mod_rewrite'] = addslashes($_POST['mod_rewrite']);
                    
                    if(trim(!empty($_SESSION['site_lang'])) AND trim(!empty($_SESSION['page_title'])) AND trim(!empty($_SESSION['page_name'])) AND trim(!empty($_SESSION['layout'])) AND trim(!empty($_SESSION['tab_length'])) AND trim(!empty($_SESSION['code_lang'])) AND trim(!empty($_SESSION['copyright'])) AND isset($_SESSION['mod_rewrite']))
                    {
                        /**
                        * create querys
                        */
                        $querys[] = "DROP TABLE IF EXISTS `".$tbl_prefix."config`;";
                        $querys[] = "CREATE TABLE `".$tbl_prefix."config` (`config_name` varchar(255) NOT NULL default '', `config_value` varchar(255) NOT NULL default '');";
                        $querys[] = "INSERT INTO `".$tbl_prefix."config` VALUES ('lang', '".$_SESSION['site_lang']."');";
                        $querys[] = "INSERT INTO `".$tbl_prefix."config` VALUES ('page_title', '".$_SESSION['page_title']."');";
                        $querys[] = "INSERT INTO `".$tbl_prefix."config` VALUES ('site_name', '".$_SESSION['page_name']."');";
                        $querys[] = "INSERT INTO `".$tbl_prefix."config` VALUES ('first_selected_lang', '".$_SESSION['code_lang']."');";
                        $querys[] = "INSERT INTO `".$tbl_prefix."config` VALUES ('std_tab', '".$_SESSION['tab_length']."');";
                        $querys[] = "INSERT INTO `".$tbl_prefix."config` VALUES ('layout', '".$_SESSION['layout']."');";
                        $querys[] = "INSERT INTO `".$tbl_prefix."config` VALUES ('copyright', '".$_SESSION['copyright']."');";
                        $querys[] = "INSERT INTO `".$tbl_prefix."config` VALUES ('gnopaste_version', 'v0.5.5');";
                        $querys[] = "INSERT INTO `".$tbl_prefix."config` VALUES ('mod_rewrite', '".$_SESSION['mod_rewrite']."');";
                        $querys[] = "DROP TABLE IF EXISTS `".$tbl_prefix."pastes`;";
                        $querys[] = "CREATE TABLE `".$tbl_prefix."pastes` (`id` int(10) NOT NULL auto_increment, `cryptid` varchar(32) NOT NULL default '', `name` varchar(100) NOT NULL default '', `description` text NOT NULL, `code` text NOT NULL, `tab_length` int(1) NOT NULL default '0', `code_lang` varchar(20) NOT NULL default '', `time` int(20) NOT NULL default '0', `ip` varchar(15) NOT NULL default '',PRIMARY KEY  (`id`));";

                        foreach($querys AS $value)
                        {
                            echo('      query: '.$value.' ');
                            if(mysql_query($value))
                            {
                                echo('<span style="color:green; font-weight:bold;">OK</span>');
                            }
                            else
                            {
                                echo('<span style="color:red; font-weight:bold;">FAILED</span>');
                            }
                            echo('<br />'."\n");
                        }
                        echo('<br />'."\n");

                        echo('      mysql tables written <span style="color:green; font-weight:bold;">OK</span><br /><br />'."\n");
                        $_SESSION['main_config'] = 'true';
                        echo('      <a href="?install=step3">finalize installation</a>'."\n");
                    }
                    else
                    {
                        /**
                        * error - any form field of the main settings is empty
                        */
                        echo('      you have to fill out every field <span style="color:red; font-weight:bold;">FAILED</span><br /><br />'."\n");
                        echo('      <a href="?install=step2">back to form</a>'."\n");
                    }
                }
            }
            else
            {
                /**
                * error - step 1 is not done
                */
                echo('      first you have to follow step 1 or your session is expired <span style="color:red; font-weight:bold;">FAILED</span><br /><br />'."\n");
                echo('      <a href="?install=step1">back to step 1</a>'."\n");
            }

        break;
        case 'step3':

            echo('step 3</h2>'."\n");

            if(isset($_SESSION['mysqldata']) AND $_SESSION['mysqldata'] == 'true' AND isset($_SESSION['main_config']) AND $_SESSION['main_config'] == 'true')
            {
                echo('      to finalize the installation we try to delete the install.php automaticly...<br /><br />'."\n");
                
                if(@unlink('install.php'))
                {
                    echo('      deleting install.php <span style="color:green; font-weight:bold;">OK</span><br /><br />'."\n");
                }
                else
                {
                    echo('      deleting install.php <span style="color:red; font-weight:bold;">FAILED</span><br />'."\n");
                    echo('      info: you have to delete install.php manualy or the script won\'t work<br /><br />'."\n");
                }

                if($_SESSION['mod_rewrite'])
                {
                    echo('      you have to move the file _.htaccess to .htaccess or you have to write the content for<br />'."\n");
                    echo('      mod_rewrite to your apache config. don\'t forget to change the domain and rewrite base<br /><br />'."\n");
                }
                
                echo('      now we are ready and you can go to the gnopaste...<br /><br />'."\n");
                echo('      <a href="index.php">go to gnopaste</a>'."\n");
            }
            else
            {
                if(!isset($_SESSION['mysqldata']) AND !isset($_SESSION['main_config']))
                {
                    /**
                    * error - step 1 is not done
                    */
                    echo('      first you have to follow step 1 or your session is expired <span style="color:red; font-weight:bold;">FAILED</span><br /><br />'."\n");
                    echo('      <a href="?install=step1">back to step 1</a>'."\n");
                }
                if(isset($_SESSION['mysqldata']) AND !isset($_SESSION['main_config']))
                {
                    /**
                    * error - step 2 is not done
                    */
                    echo('      first you have to follow step 2 or your session is expired <span style="color:red; font-weight:bold;">FAILED</span><br /><br />'."\n");
                    echo('      <a href="?install=step2">back to step 2</a>'."\n");
                }
            }
            
        break;
        default:
        
            echo('start</h2>'."\n");
            
            echo('      welcome to the installation of gnopaste v0.5.5<br /><br />'."\n");
            echo('      please follow exactly the installation instructions<br /><br />'."\n");
            echo('      <a href="?install=step1">start with the installation</a>'."\n");
            
        break;
    }
    
    echo('  </body>'."\n");
    echo('</html>'."\n");
?>
